unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, Process;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  POctave: TProcess;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if (not POctave.Running) then
  begin
    POctave.Executable := 'C:\Octave\Octave-4.2.0\bin\octave-cli.exe';
    POctave.Parameters.Add('--no-gui');
    POctave.Options := [poUsePipes];
    WriteLn('-- Executing octave --');
    POctave.Execute;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  command: string;
  Buffer: string;
  BytesAvailable: DWord;
  BytesRead: longint;
  NoMoreOutput: boolean;
begin
  command := 'pwd' + #10;
  if (POctave.Running) then
    POctave.Input.Write(command, Length(command));

  if (POctave.Running) then
  begin
    BytesAvailable := POctave.Output.NumBytesAvailable;
    BytesRead := 0;
    while BytesAvailable > 0 do
    begin
      SetLength(Buffer, BytesAvailable);
      BytesRead := POctave.OutPut.Read(Buffer[1], BytesAvailable);
      WriteLn(Buffer);
      BytesAvailable := POctave.Output.NumBytesAvailable;
      NoMoreOutput := False;
    end;
  end;
end;

initialization
  POctave := TProcess.Create(nil);

finalization
  POctave.Free;

end.
